<!doctype html>
<html>

<head>
  <meta name="generator" content="JSDoc 3.6.3">
  <meta charset="utf-8">
  <title>Source: ads/banner/Banner.js</title>
  <link rel="stylesheet" href="https://brick.a.ssl.fastly.net/Karla:400,400i,700,700i" type="text/css">
  <link rel="stylesheet" href="https://brick.a.ssl.fastly.net/Noto+Serif:400,400i,700,700i" type="text/css">
  <link rel="stylesheet" href="https://brick.a.ssl.fastly.net/Inconsolata:500" type="text/css">
  <link href="css/baseline.css" rel="stylesheet">
</head>

<body onload="prettyPrint()">
  <nav id="jsdoc-navbar" role="navigation" class="jsdoc-navbar">
    <div id="jsdoc-navbar-container">
      <div id="jsdoc-navbar-content">
        <a href="index.html" class="jsdoc-navbar-package-name">Home</a>
      </div>
    </div>
  </nav>
  <div id="jsdoc-body-container">
    <div id="jsdoc-content">
      <div id="jsdoc-content-container">
        <div id="jsdoc-banner" role="banner">
        </div>
        <div id="jsdoc-main" role="main">
          <header class="page-header">
            <h1>Source: ads/banner/Banner.js</h1>
          </header>
          <article>
            <pre class="prettyprint linenums"><code>import style from &#x27;./style.scss&#x27;
import { Ad } from &#x27;../Ad&#x27;

let classNames &#x3D; (require(&#x27;classnames/bind&#x27;)).bind(style)

/**
 * za banner uważamy klikalny komponent o niepływającym (fixed, sticky, absolute) position
 * komponent jest traktowany zarówno bezpośrednio jako reklama, jak i jako komponent w innych formach reklamowych (np. interstitial)
 * @class Banner
 * @extends {Ad}
 */
export class Banner extends Ad {
  constructor (props, state) {
    super(props, state)

    /**
      * IntersectionObserver weryfikujacy obecność pojemnika w wiewporcie
      * @see https://developer.mozilla.org/en-US/docs/Web/API/Intersection_Observer_API
      * @see https://developers.google.com/web/updates/2019/02/intersectionobserver-v2
      */
    this.observer &#x3D; null

    /** domyślnie zakładamy, że element jest niewidoczny w viewporcie; stan ten może ulec zmianie dopiero po aktywacji IntersectionObservera */
    this.state.viewport &#x3D; &#x27;hidden&#x27;

    if (&#x27;width&#x27; in this.props) this.props.style.width &#x3D; this.props.style.maxWidth &#x3D; this.props.width /** ustawia max-width, by umożliwić skalowanie */
    if (&#x27;height&#x27; in this.props) this.props.style.height &#x3D; this.props.height
    if (!(&#x27;redirectLayer&#x27; in this.props)) this.props.redirectLayer &#x3D; false

    // @see https://reactjs.org/docs/components-and-props.html#es6-classes
    // @see https://medium.com/shoutem/react-to-bind-or-not-to-bind-7bf58327e22a
    this.classNames &#x3D; this.classNames.bind(this)
    this.onReady &#x3D; this.onReady.bind(this)
    this.mountIntersectionObserver &#x3D; this.mountIntersectionObserver.bind(this)
    this.onViewportEnter &#x3D; this.onViewportEnter.bind(this)
    this.onViewportLeave &#x3D; this.onViewportLeave.bind(this)
  }

  classNames () {
    return classNames([
      this.cssClasses,
      this.props.classNames,
      {
        ready: this.state.lifecycle &#x3D;&#x3D;&#x3D; &#x27;ready&#x27; &amp;amp;&amp;amp; this.state.preloading &#x3D;&#x3D;&#x3D; 0,
        visible: this.state.viewport !&#x3D;&#x3D; &#x27;hidden&#x27; &amp;amp;&amp;amp; this.state.lifecycle &#x3D;&#x3D;&#x3D; &#x27;ready&#x27; &amp;amp;&amp;amp; this.state.preloading &#x3D;&#x3D;&#x3D; 0
      }
    ])
  }

  /**
   * inicjalizuje obiekt IntersectionObserver przypisany do głównego pojemnika komponentu
   */
  mountIntersectionObserver () {
    this.observer &#x3D; new IntersectionObserver(
      changes &#x3D;&gt; {
        for (const change of changes) {
          /** sprawdza, czy przeglądarka obsługuje IntersectionObserver V2, umozliwiającego sprawdzanie realnej widoczności elementu (opacity, translate, scale, etc.) */
          if (typeof change.isVisible &#x3D;&#x3D;&#x3D; &#x27;undefined&#x27;) {
            change.isVisible &#x3D; true
          }
          if (change.isIntersecting &amp;amp;&amp;amp; change.isVisible) {
            this.observer.visibleSince &#x3D; change.time
            this.observer.wasVisible &#x3D; true
            this.onViewportEnter()
          } else if (this.observer.wasVisible) {
            this.onViewportLeave()
          } else {
            this.observer.visibleSince &#x3D; 0
          }
        }
      },
      {
        root: null,
        rootMargin: &#x27;0px&#x27;,
        threshold: 0.5,
        trackVisibility: true,
        delay: 100
      }
    )

    /** aktywuje obiekt IntersectionObserver, przypisując go bezpośrednio do komponentu */
    this.observer.observe(this.base)

    /**
     * determinuje, czy element był kiedykolwiek widoczny; wykorzystywane, by uruchamiać funkcję onViewportLeave
     * @type {bool}
     */
    this.observer.wasVisible &#x3D; false

    /**
     * czas w milisekundach, jaki element spędził w viewporcie
     * @type {number}
     */
    this.observer.visibleSince &#x3D; 0
  }

  /**
   * wejście w obszar viewportu, zgodnie z ustawieniami IntersectionObservera
   */
  onViewportEnter () {
    this.setState({ viewport: &#x27;enter&#x27; })
    if (typeof this.props.onViewportEnter &#x3D;&#x3D;&#x3D; &#x27;function&#x27;) this.props.onViewportEnter()
  }
  /**
   * wyjście z obszaru viewportu, zgodnie z ustawieniami IntersectionObservera
   */
  onViewportLeave () {
    this.setState({ viewport: &#x27;leave&#x27; })
    if (typeof this.props.onViewportLeave &#x3D;&#x3D;&#x3D; &#x27;function&#x27;) this.props.onViewportLeave()
  }

  componentDidMount () {
    this.mountIntersectionObserver()
  }
}
</code></pre>
          </article>
        </div>
      </div>
      <nav id="jsdoc-toc-nav" role="navigation"></nav>
    </div>
  </div>
  <footer id="jsdoc-footer" class="jsdoc-footer">
    <div id="jsdoc-footer-container">
      <p>
        Generated by <a href="https://github.com/jsdoc3/jsdoc">JSDoc</a> 3.6.3 on August 23, 2019.
      </p>
    </div>
  </footer>
  <script src="scripts/jquery.min.js"></script>
  <script src="scripts/jquery.cookie.js"></script>
  <script src="scripts/tree.jquery.js"></script>
  <script src="scripts/prettify.js"></script>
  <script src="scripts/jsdoc-toc.js"></script>
  <script src="scripts/linenumber.js"></script>
  <script src="scripts/scrollanchor.js"></script>
</body>

</html>